=== added directory 'webui'
=== added file 'webui/config.json'
--- webui/config.json	1970-01-01 00:00:00 +0000
+++ webui/config.json	2014-01-23 19:29:38 +0000
@@ -0,0 +1,3 @@
+{
+  "ticket_manager_url": "http://example.com"
+}

=== added file 'webui/index.html'
--- webui/index.html	1970-01-01 00:00:00 +0000
+++ webui/index.html	2014-01-23 19:29:38 +0000
@@ -0,0 +1,18 @@
+<html>
+  <head>
+    <script type="text/javascript" src="http://yui.yahooapis.com/3.14.0/build/yui/yui.js"></script>
+    <script type="text/javascript" src="webui.js"></script>
+    <script type="text/javascript" src="webui_ticket_list.js"></script>
+    <link rel="stylesheet" href="webui.css">
+    <title>CI Engine Web UI</title>
+  </head>
+  <body id="doc">
+
+
+    <div id="table" class="yui3-skin-sam"></div>
+    Click a row for details.
+    <div id="container"></div>
+    Refresh every <input type="text" id="refresh_rate" value="10" maxlength="3" size="2"/> Seconds.
+             
+  </body>
+</html>

=== added file 'webui/test_webui.html'
--- webui/test_webui.html	1970-01-01 00:00:00 +0000
+++ webui/test_webui.html	2014-01-23 19:29:38 +0000
@@ -0,0 +1,144 @@
+<html>
+  <head>
+    <script type="text/javascript" src="http://yui.yahooapis.com/3.14.0/build/yui/yui.js"></script>
+    <script type="text/javascript" src="webui.js"></script>
+  </head>
+
+  <body>
+    <div id="table"></div>
+    <script type="text/javascript">
+    YUI().use('test', 'console', 'webui', function(Y) {
+      // Test data
+      var td_item = {
+        id: 0,
+        title: "blah",
+        current_workflow_step: "New",
+        status: "New",
+        ticket_id: 0
+      };
+
+      var td_subticket = {
+        artifact: [],
+        assignee: "me@example.com",
+        current_workflow_step: "New",
+        id: 0,
+        resource_uri: "/api/v1/blah",
+        source_package_upload: {},
+        status: "New"
+      }
+
+      var td_artifact_1 = {
+        id: 0,
+        name: "/tmp/somefile.tgz",
+        reference: "http://example.com/somefile.tgz",
+        resource_uri: "/api/v1/fullartifact/0/",
+        type: "SPU"
+      }
+
+      var td_artifact_2 = {
+        id: 1,
+        name: "/tmp/someotherfile.tgz",
+        reference: "http://example.com/someotherfile.tgz",
+        resource_uri: "/api/v1/fullartifact/1/",
+        type: "SPU"
+      }
+
+      var testcase = new Y.Test.Case({
+        name: "WebUI tests",
+        test_ticket_detail_element: function() {
+          data = {
+            id: 1,
+            title: "blah blah",
+            resource_uri: "http://example.com/ticket/1/",
+            description: "blah blah blah blah",
+            owner: "noone@example.com"
+          };
+
+          table = Y.webui.ticket_detail_element(data);
+          Y.Assert.areNotEqual(undefined, table);
+
+          rows = table.all('tr');
+          Y.Assert.areEqual(2, rows.size()); // Title is in an <h3>
+        },
+        test_make_main_table: function() {
+          Y.webui.make_main_table('#table');
+
+          Y.Assert.isTrue(Y.webui.main_table !== undefined);
+        },
+        test_add_subticket: function() {
+          Y.webui.make_main_table('#table');
+          var selector = 'div.subticket';
+
+          td_item['subticket'] = [td_subticket];
+
+          Y.Assert.areEqual(0, Y.all(selector).size());
+
+          var table = Y.webui.ticket_detail_element(td_item);
+          Y.one("#table").replace(table);
+          Y.Assert.areEqual(1, Y.all(selector).size());
+        },
+        test_basename: function() {
+          var filename = "file.tgz";
+          var full_name = "/home/nobody/" + filename;
+          var name = Y.webui.basename(full_name);
+
+          Y.Assert.areEqual(filename, name);
+        },
+        test_add_artifacts: function() {
+          var data = [td_artifact_1, td_artifact_2];
+
+          output = Y.webui.add_artifacts(data);
+          Y.Assert.areEqual(2, output.all('a').size());
+        },
+        test_artifact_link: function() {
+          var data = td_artifact_1;
+          var ad = Y.webui.artifact_link(data);
+          var name = Y.webui.basename(data['name']);
+          Y.Assert.areEqual(Y.webui.basename(data['name']), name);
+        },
+        test_add_item: function() {
+
+          Y.webui.make_main_table('#table');
+
+          var previous_row_count = Y.webui.main_table.get('data').size();
+
+          Y.webui.add_item(td_item);
+
+          var current_row_count = Y.webui.main_table.get('data').size();
+
+          Y.Assert.areEqual(previous_row_count + 1, current_row_count);
+        },
+        test_make_subticket: function() {
+          var subticket = Y.webui.make_subticket(td_subticket);
+          Y.Assert.isTrue(subticket.hasClass('subticket'));
+          Y.Assert.areEqual(1, subticket.all('table').size());
+          Y.Assert.areEqual(5, subticket.all('tr').size());
+        },
+        test_sp_upload: function() {
+          var data = {
+            id: 0,
+            resource_uri: "/spu/0/",
+            sourcepackage: {
+              id: 1,
+              name: "blah",
+              resource_uri: "/sp/blah/1/"
+            },
+            version: "0.1-1"
+          }
+          var sp = Y.webui.sp_upload(data);
+          var expected_text = data.sourcepackage.name + " " + data.version;
+
+          Y.Assert.areEqual(expected_text, sp.getHTML());
+        }
+      });
+
+      var yconsole = new Y.Console({
+        newestOnTop: false
+      });
+
+      Y.Test.Runner.add(testcase);
+      Y.Test.Runner.run();
+    });
+    </script>
+  </body>
+</html>

=== added file 'webui/ticket.html'
--- webui/ticket.html	1970-01-01 00:00:00 +0000
+++ webui/ticket.html	2014-01-23 19:29:38 +0000
@@ -0,0 +1,14 @@
+<html>
+  <head>
+    <script type="text/javascript" src="http://yui.yahooapis.com/3.14.0/build/yui/yui.js"></script>
+    <script type="text/javascript" src="webui.js"></script>
+    <script type="text/javascript" src="webui_ticket_detail.js"></script>
+    <link rel="stylesheet" href="webui.css">
+    <title>CI Engine Web UI Ticket Details</title>
+  </head>
+  <body id="doc">
+    <div id="container"></div>
+    Refresh every <input type="text" id="refresh_rate" value="10" maxlength="3" size="2"/> Seconds.
+             
+  </body>
+</html>

=== added file 'webui/webui.css'
--- webui/webui.css	1970-01-01 00:00:00 +0000
+++ webui/webui.css	2014-01-23 19:29:38 +0000
@@ -0,0 +1,110 @@
+#doc {
+  margin: auto;
+  width: 800px;
+  min-width: 600px;
+  text-align: center;
+}
+
+div {
+  padding: 5px;
+  overflow: auto;
+  margin: 0 auto;
+}
+
+div.row {
+	border-style: none;
+}
+
+.grid:after {
+	content: "";
+	display: table;
+	clear: both;
+}
+
+div.subticket,div.ticket {
+  border: 2px solid black;
+  display: block;
+  /*
+  width: 30%;
+  float: left;
+  */
+  margin: 5px;
+  text-align: left;
+  -moz-border-radius: 5px;
+  -webkit-border-radius: 5px;
+  -khtml-border-radius: 5px;
+  border-radius: 5px;
+  background-color: lightgray;
+}
+
+div.subticket,div.ticket,h3,h2 {
+  text-align: center;
+}
+
+.red {
+  color: red;
+}
+
+.red table {
+  color: red;
+}
+
+div.item h3 {
+  text-align: center;
+}
+
+/*
+[class*='col-'] {
+	float: left;
+}
+*/
+
+.col-1 {
+  width: 90%;
+}
+
+/*
+.col-1-3 {
+	width: 33.33%;
+}
+*/
+
+.yui3-skin-sam .yui3-datatable-table {
+  margin: 0 auto;
+}
+
+table {
+  margin: 0 auto;
+}
+
+table,tr,td,th {
+  border: 1px solid lightgray;
+  border-collapse: separate;
+  border-spacing: 0.05em;
+  padding: 0.1em 0.5em 0.1em 0.5em;
+}
+
+tr.yui3-datatable-even,tr.yui3-datatable-odd {
+  cursor: pointer;
+}
+
+/*
+tr:nth-child(even) {
+  background-color: rgb(237, 245, 255);
+}
+
+tr.subticket {
+  background-color: white;
+}
+
+tr.subticket:nth-child(even) {
+  background-color: rgb(237, 245, 255);
+}
+*/
+
+th {
+  text-align: right;
+  /*
+  background: linear-gradient(transparent 40%, rgba(0, 0, 0, 0.21)) repeat-x scroll 0px 0px rgb(255, 255, 255)
+  */
+}

=== added file 'webui/webui.js'
--- webui/webui.js	1970-01-01 00:00:00 +0000
+++ webui/webui.js	2014-01-23 19:29:38 +0000
@@ -0,0 +1,271 @@
+YUI.add('webui', function(Y) {
+  Y.webui = {
+    url_prefix: "/api/",
+    get_config: function() {
+      Y.io("config.json", {
+        on: {
+          success: function(tx, r) {
+            var data;
+
+            try {
+              data = Y.JSON.parse(r.responseText);
+            }
+            catch (e) {
+              alert("JSON Parse failed");
+              return;
+            }
+          }
+        }
+      });
+    },
+    update_tickets: function() {
+      if (Y.webui.main_table) {
+        Y.webui.get_tickets();
+      }
+
+      var running = Y.all(".running");
+      if (running.size() > 0) {
+        refresh_timeout = setTimeout(update_tickets, interval);
+      }
+    },
+    get_ticket: function(ticket_id, elem) {
+      var table = null;
+      data = Y.io(Y.webui.url_prefix + "fullticket/" + ticket_id + "/", {
+        on: {
+          success: function(tx, r) {
+            console.log("success");
+            var data;
+
+            try {
+              data = Y.JSON.parse(r.responseText);
+            }
+            catch (e) {
+              alert("JSON Parse failed");
+              return;
+            }
+
+            var new_div =  Y.webui.ticket_detail_element(data);
+            elem.setHTML(new_div);
+
+          },
+          failure: function(tx, r, e) {
+            console.log("failure: ", tx, r, e);
+          }
+        }
+      });
+    },
+    get_tickets: function() {
+      container = Y.one('#container');
+      data = Y.io(Y.webui.url_prefix + "ticket/", {
+        on: {
+          success: function(tx, r) {
+            console.log("success");
+            var data;
+
+            try {
+              data = Y.JSON.parse(r.responseText);
+            }
+            catch (e) {
+              alert("JSON Parse failed");
+              return;
+            }
+
+            for (var i = 0; i < data.objects.length; i++) {
+              Y.webui.add_item(data.objects[i]);
+            }
+          },
+          failure: function(tx, r, e) {
+            console.log("failure: ", tx, r, e);
+          }
+        }
+      });
+    },
+    add_subticket: function(data) {
+      var main_tr = Y.Node.create("<tr>");
+      main_tr.appendChild(Y.Node.create('<th>subticket</th>'));
+      for (var key in data) {
+        var value = data[key];
+
+        var tr = main_tr.appendChild(Y.Node.create('<tr>'));
+        tr.addClass('subticket');
+        tr.appendChild(Y.Node.create('<th>' + key + '</th>'));
+        tr.appendChild(Y.Node.create('<td>' + value + '</td>'));
+      }
+
+      main_tr.addClass('subticket');
+      return main_tr;
+    },
+    make_subticket: function(data) {
+      var div = Y.Node.create("<div class='subticket'></div>");
+
+      var table = div.appendChild(Y.Node.create("<table>"));
+      var hidden_fields = Y.Array(['id', 'resource_uri']);
+
+      for (var key in data) {
+        // Skip hidden fields
+        if (Y.Array.indexOf(hidden_fields, key) != -1) {
+          continue;
+        }
+
+        var value = data[key];
+        if (key == 'artifact') {
+          var span = Y.webui.add_artifacts(data['artifact']);
+          value = span.getHTML();
+        }
+
+        if (key == 'source_package_upload') {
+          var span = Y.webui.sp_upload(data['source_package_upload']);
+          value = span.getHTML();
+        }
+
+        var tr = table.appendChild(Y.Node.create('<tr>'));
+        tr.appendChild(Y.Node.create('<th>' + key + ': </th>'));
+        tr.appendChild(Y.Node.create('<td>' + value + '</td>'));
+      }
+
+      return div;
+    },
+    basename: function(path) {
+      return path.replace(/^.*\//, "");
+    },
+    add_artifacts: function(data) {
+      var span = Y.Node.create('<span></span>');
+      for (var i = 0; i < data.length; i++) {
+        span.appendChild(Y.webui.artifact_link(data[i]));
+        span.appendChild(Y.Node.create("<br/>"));
+      }
+
+      return span;
+    },
+    artifact_link: function(data) {
+      var name = Y.webui.basename(data['name']);
+      var link = Y.Node.create("<a/>");
+      link.set('href', data['reference']);
+      link.set('text', name);
+
+      return link;
+    },
+    sp_upload: function(data) {
+      var span = Y.Node.create("<span></span>");
+
+      if (data.sourcepackage) {
+        span.setHTML(data.sourcepackage.name + " " + data.version);
+      }
+
+      return span;
+    },
+    ticket_detail_element: function(data) {
+      var hidden_fields = Y.Array(['id', 'title', 'subticket', 'resource_uri']);
+
+      div = Y.Node.create("<div id='table_wrapper'/>");
+      ticket_div = div.appendChild(Y.Node.create("<div class='ticket'></div>"));
+      table = ticket_div.appendChild(Y.Node.create("<table></table>"));
+
+      if (data['title']) {
+        div.prepend(Y.Node.create('<h2>' + data['title'] + '</h2>'));
+      }
+
+      for (var key in data) {
+        var value = data[key];
+
+        if (Y.Array.indexOf(hidden_fields, key) != -1) {
+          continue;
+        }
+
+        if (key == "title" || key == "subticket") {
+          continue;
+        }
+
+        tr = Y.Node.create('<tr></tr>');
+        table.appendChild(tr);
+        tr.appendChild(Y.Node.create('<th>' + key + '</th>'));
+        tr.appendChild(Y.Node.create('<td>' + value + '</td>'));
+      }
+
+      if (data['subticket']) {
+        div.appendChild("<h3>Subtickets</h3>");
+        var subticket_count = data['subticket'].length;
+        if (subticket_count > 0) {
+          for (var i = 0; i < subticket_count; i++) {
+            var subticket = data['subticket'][i];
+
+            var subt = Y.webui.make_subticket(subticket);
+
+            div.appendChild(subt);
+          }
+        }
+      }
+      return div;
+    },
+    check_ticket: function(e) {
+      var elem = this;
+      var id = elem.get('id').replace('item-', '');
+
+      data = Y.io(Y.webui.url_prefix +  "status/" + id + "/", {
+        on: {
+          success: function(tx, r) {
+            var data;
+
+            try {
+              data = Y.JSON.parse(r.responseText);
+            }
+            catch (e) {
+              alert("JSON Parse failed");
+              return;
+            }
+
+            var update_fields = ['status', 'title', 'current_workflow_step', 'updated'];
+
+            for (i = 0; i < update_fields.length; i++) {
+              var field_name = update_fields[i];
+              var field = elem.one('#' + field_name + '-' + id);
+              var old_value = field.getHTML();
+              var new_value = data[field_name];
+              if (field && new_value && old_value != new_value) {
+                field.setHTML(new_value);
+              }
+            }
+            // HACK for development testing
+            var new_status = data['status'];
+            if (new_status == 440) {
+              elem.addClass('red');
+            } else {
+              elem.removeClass('red');
+            }
+          }
+        }
+      });
+    },
+    add_item: function(item) {
+      var entry = item;
+      var id = entry['id'];
+      var table = Y.webui.main_table;
+
+      if (table) {
+        var tr = table.addRow({
+          title: entry['title'],
+          current_workflow_step: entry['current_workflow_step'],
+          status: entry['status'],
+          ticket_id: id
+        });
+      }
+    },
+    make_main_table: function(div_id) {
+
+      var columns = [
+        {key: 'title', label: 'Title'},
+        {key: 'current_workflow_step', label: 'Workflow Step'},
+        {key: 'status', label: 'Status'}
+      ]
+      var data = [];
+
+      var main_table = new Y.DataTable({
+        columnset: columns,
+        recordset: data
+      });
+      main_table.render(div_id);
+
+      Y.webui.main_table = main_table;
+    }
+  };
+}, '0.0.1', {requires: ['io', 'node', 'json-parse', 'datatable']});

=== added file 'webui/webui_ticket_detail.js'
--- webui/webui_ticket_detail.js	1970-01-01 00:00:00 +0000
+++ webui/webui_ticket_detail.js	2014-01-23 19:29:38 +0000
@@ -0,0 +1,34 @@
+YUI().use('io', 'json-parse', 'querystring', 'node', 'webui', function(Y) {
+
+  var url_prefix = "/api/";
+
+  var query = window.location.search.split('?')[1];
+
+  var ticket_id = null;
+  if (query) {
+    var ob = Y.QueryString.parse(query);
+    var ticket_id = ob.ticket_id;
+  }
+  Y.webui.get_config();
+
+  if (ticket_id) {
+    var ticket = Y.webui.get_ticket(ticket_id, Y.one('#container'));
+  }
+
+  var refresh_rate = Y.one("#refresh_rate");
+  refresh_timeout = null;
+  refresh_rate.on('change', function(e) {
+    var value = refresh_rate.get('value');
+    if (refresh_timeout) {
+      clearTimeout(refresh_timeout);
+    }
+    interval = parseInt(value) * 1000;
+    Y.webui.update_tickets();
+  });
+
+});
+
+/* Unit tests */
+YUI().use('webui', function(Y) {
+
+});

=== added file 'webui/webui_ticket_list.js'
--- webui/webui_ticket_list.js	1970-01-01 00:00:00 +0000
+++ webui/webui_ticket_list.js	2014-01-23 19:29:38 +0000
@@ -0,0 +1,36 @@
+YUI().use('node', 'datatable-mutable', 'webui', function(Y) {
+
+  var url_prefix = "/api/";
+  var uri = 'api_example.json';
+
+  Y.webui.make_main_table('#table');
+
+  Y.delegate('click', function(e) {
+    var target = e.currentTarget;
+    var id = target.ancestor('tr').get('id');
+    var ticket_id = this.getRecord(id).get('ticket_id');
+    var url = "/ticket.html?ticket_id=" + ticket_id;
+
+    location = url;
+  }, '#table', 'td', Y.webui.main_table); 
+
+  Y.webui.get_config();
+  Y.webui.get_tickets();
+
+  var refresh_rate = Y.one("#refresh_rate");
+  refresh_timeout = null;
+  refresh_rate.on('change', function(e) {
+    var value = refresh_rate.get('value');
+    if (refresh_timeout) {
+      clearTimeout(refresh_timeout);
+    }
+    interval = parseInt(value) * 1000;
+    Y.webui.update_tickets();
+  });
+
+});
+
+/* Unit tests */
+YUI().use('webui', function(Y) {
+
+});

